#ifndef _WIN32_APE

#ifndef APE_NOWINDOWS_H
#define APE_NOWINDOWS_H

#define FALSE    0
#define TRUE     1

#define NEAR
#define FAR

typedef unsigned int        uint32;
typedef int                 int32;
typedef unsigned short      uint16;
typedef short               int16;
typedef unsigned char       uint8;
typedef char                int8;
typedef char                str_ansi;
typedef unsigned char       str_utf8;
typedef wchar_t             str_utf16;

typedef unsigned long       DWORD;
typedef int                 BOOL;
typedef unsigned char       BYTE;
typedef unsigned short      WORD;
typedef float               FLOAT;
typedef void *              HANDLE;
typedef unsigned int        UINT;
#ifndef _WIN32_APE
typedef unsigned int        WPARAM;
typedef long                LPARAM;
#endif
typedef const char *        LPCSTR;
typedef const wchar_t *		LPCWSTR;
typedef char *              LPSTR;
#ifndef _WIN32_APE
typedef long                LRESULT;
#endif

#define ZeroMemory(POINTER, BYTES) memset(POINTER, 0, BYTES);

#ifndef MAX
#define MAX(a,b)    (((a) > (b)) ? (a) : (b))
#endif
#ifndef MIN
#define MIN(a,b)    (((a) < (b)) ? (a) : (b))
#endif

//#define __stdcall

#ifndef _WIN32_APE
#define CALLBACK
#endif

#define _stricmp strcasecmp


#ifndef _FPOSOFF
#define _FPOSOFF(fp) ((long)(fp).__pos)
#endif
#define MAX_PATH    260

#ifndef _WAVEFORMATEX_
#define _WAVEFORMATEX_

typedef struct tWAVEFORMATEX
{
    WORD        wFormatTag;         /* format type */
    WORD        nChannels;          /* number of channels (i.e. mono, stereo...) */
    DWORD       nSamplesPerSec;     /* sample rate */
    DWORD       nAvgBytesPerSec;    /* for buffer estimation */
    WORD        nBlockAlign;        /* block size of data */
    WORD        wBitsPerSample;     /* number of bits per sample of mono data */
    WORD        cbSize;             /* the count in bytes of the size of */
                    /* extra information (after cbSize) */
} WAVEFORMATEX, *PWAVEFORMATEX, NEAR *NPWAVEFORMATEX, FAR *LPWAVEFORMATEX;
typedef const WAVEFORMATEX FAR *LPCWAVEFORMATEX;

#endif // #ifndef _WAVEFORMATEX_

#endif // #ifndef APE_NOWINDOWS_H

#endif // #ifndef _WIN32_APE
